----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 04/06/2017 06:09:38 PM
-- Design Name: 
-- Module Name: VGA - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity VGA is
    Port ( clk50 : in STD_LOGIC;
           hsync : out STD_LOGIC;
           vsync : out STD_LOGIC;
           rgb : out STD_LOGIC_VECTOR(2 downto 0);
           cx : out UNSIGNED(9 downto 0); 
           cy : out UNSIGNED(9 downto 0); 
           en : out STD_LOGIC);
end VGA;

architecture Behavioral of VGA is

signal hst: unsigned (10 downto 0);
signal vst: unsigned (9 downto 0);

constant H: integer := 1040;
constant Hp: integer := 800;
constant Hf: integer := 856;
constant Hs: integer := 120;

constant V: integer := 666;
constant Vp: integer := 600;
constant Vf: integer := 637;
constant Vs: integer := 6;

begin

process(clk50, vst, hst)
begin
if rising_edge(clk50) then
    if hst < H-1 then
        hst <= hst + 1;
    else
        hst <= (others => '0');
        if vst < V-1 then
            vst <= vst + 1;
        else
            vst <= (others => '0');
         end if;
     end if;
end if;
end process;

cx <= hst(9 downto 0);
cy <= vst;

process(hst,vst)
begin
if hst<=Hp and vst<=Vp then 
   rgb <= "010";
   en <='1'; -- enable: ko je 1 smo znotraj vidnega polja (800x600) in takrat riemo sliko
  else
      en<='0';
      rgb<="000";   
end if;   
end process;  

hsync <='1' when hst>=Hf and hst<Hf+Hs else '0';
vsync <='1' when vst>=Vf and vst<Vf+Vs else '0';

end Behavioral;
