----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 05/17/2017 10:37:04 PM
-- Design Name: 
-- Module Name: IPvmesnik - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity IPvmesnik is
    Port ( clk : in STD_LOGIC;
           din : in STD_LOGIC;
           sck, load : out STD_LOGIC;
           t: out STD_LOGIC_VECTOR(3 downto 0);
           selx, sely : out STD_LOGIC_VECTOR (1 downto 0));
end IPvmesnik;

architecture Behavioral of IPvmesnik is
 signal div: integer range 0 to 1000 := 0;
 signal n: integer range 0 to 7 := 0;
 signal tmp: std_logic_vector(5 downto 0) := "000000";
 signal c, t2, t1, vh2, vh1: std_logic := '0';

 component avt is
    Port ( t1 : in  STD_LOGIC;
           t2 : in  STD_LOGIC;
           vh1 : in  STD_LOGIC;
           vh2 : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           selx : out  STD_LOGIC_VECTOR (1 downto 0);
           sely : out  STD_LOGIC_VECTOR (1 downto 0));
 end component;
begin

u1: avt port map (t1=>t1, t2=>t2, vh1=>vh1, vh2=>vh2, clk=>clk, selx=>selx, sely=>sely);

p1: process(clk)
begin
 if rising_edge(clk) then
   if div<1000 then
     div <= div + 1;
   else
     div <= 0;
     c <= not c;
     if c='0' then
         if n < 6 then
           n <= n + 1;
         else
           n <= 0;           
           t <= tmp(3 downto 0);
           --t3 <= tmp(1);
           t2 <= tmp(2);
           t1 <= tmp(3);           
           vh2 <= tmp(4);
           vh1 <= tmp(5);
         end if;
         tmp <= din & tmp(5 downto 1);
        -- tmp(n) <= din; 
     end if;
   end if;
 end if;
end process;

load <= '1' when n=0 else '0';

sck <= c;
end Behavioral;
