----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:27:29 04/24/2017 
-- Design Name: 
-- Module Name:    vh1 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity avt is
    Port ( t1 : in  STD_LOGIC;
           t2 : in  STD_LOGIC;
           vh1 : in  STD_LOGIC;
           vh2 : in  STD_LOGIC;
           clk : in  STD_LOGIC;
           selx : out  STD_LOGIC_VECTOR (1 downto 0);
           sely : out  STD_LOGIC_VECTOR (1 downto 0));
end avt;

architecture Behavioral of avt is

signal mode: std_logic;
signal x: unsigned(1 downto 0) := "00";
signal y: unsigned(1 downto 0):= "00";

type stanja is (mir, s1, s2, imp1, imp2, cakaj);
signal st: stanja;


begin

p1: process(clk)
begin
if rising_edge(clk) then
if (t1 = '1') then
	mode <= '1';
elsif (t2 = '1') then
	mode <= '0';
end if;
end if;
end process;

preh: process(clk)
begin
if rising_edge(clk) then
	case st is
		when mir =>
			if vh1 = '1' and vh2 = '0' then
				st <= s1;
			elsif vh1 = '0' and vh2 = '1' then
				st <= s2;
			else st <= mir;
			
			end if;
			
		when s1 =>
			if vh1 = '1' and vh2 = '1' then
				st <= imp1;
				--st <= cakaj;
			else st <= s1;
			
			end if;
		
		when s2 =>
			if vh1 = '1' and vh2 = '1' then
				st <= imp2;
				--st <= cakaj;
			else st <= s2;
			
			end if;
			
		when imp1 =>
		  st <= cakaj;
		  
		 when imp2 =>
          st <= cakaj;
		  
		 
			
		when cakaj =>
			if vh1 = '0' and vh2 = '0' then
				st <= mir;
			else st <= cakaj;
			
			end if;
			
		when others =>
		  st <= mir;	
			
		end case;
end if;
end process;

--V vezju naj bosta dva števca, ki ju deklariraj kot 2-bitna nepredznačena (unsigned) notranja signala x in y.
--Vrednost števca naj se poveča za 1 ob fronti ure in stanju imp1, ob imp2 pa zmanjša za 1. Signal mode določa
--kateremu izmed števcev spreminjamo vrednost: pri mode = 0, naj se spreminja x, pri mode = 1 pa y. Vsebino
--števcev priredi izhodoma selx in sely
		
stevec: process(clk, st, x, y, mode)
begin
if rising_edge(clk) then
	case mode is
		when '0' =>
			if st = imp1 and x<3 then
				x <= x + 1;
			elsif st = imp2 and x>0 then
				x <= x - 1;
			end if;
		
		when others =>
			if st = imp1 and y<3 then
				y <= y + 1;
			elsif st = imp2 and y>0 then
				y <= y - 1;
			end if;		
    end case;
 end if;

end process;
 
selx <= std_logic_vector(x);
sely <= std_logic_vector(y); 
 
end Behavioral;

